import { Component, OnInit } from '@angular/core';
import {ID3} from "../utils/id3";
import {Tennis} from "../utils/training-data/tennis";
import {without, keys, filter} from "lodash";
import {CreditCard} from "../utils/training-data/credit-card";

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit {
    tree;
    tests: any;
    accuracyPct: any;

    constructor(private id3: ID3) {
        // this.tree = this.id3.train(Tennis.data, 'play', without(keys(Tennis.data[0]), 'play'));
        this.tree = this.id3.train(CreditCard.data, 'approved', without(keys(CreditCard.data[0]), 'approved'));
    }

    ngOnInit() {

        // this.tests = [{outlook:'Overcast', temp:'Mild', humidity:'High', wind: 'Strong', expected: 'Yes'},
        //     {outlook:'Rain', temp:'Mild', humidity:'High', wind: 'Strong', expected: 'No'},
        //     {outlook:'Sunny', temp:'Cool', humidity:'Normal', wind: 'Weak', expected: 'Yes'}];
        //
        //
        this.tests = [{"creditScore":"Excellent","creditAge":">10","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"0","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"1","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"2","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">10","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"0","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"1","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"2","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">5","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"0","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"1","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"2","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">2","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"0","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"1","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"2","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"Yes"},{"creditScore":"Excellent","creditAge":">=1","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"Yes"},{"creditScore":"Good","creditAge":">10","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">10","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">10","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">10","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">10","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">10","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">5","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">5","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">5","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">5","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">5","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">2","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">2","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">2","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Good","creditAge":">2","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">2","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Good","creditAge":">=1","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Average","creditAge":">10","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Average","creditAge":">10","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">10","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"Yes"},{"creditScore":"Average","creditAge":">5","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"Yes"},{"creditScore":"Average","creditAge":">5","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">5","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">2","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Average","creditAge":">=1","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">10","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">5","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">2","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"0","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"0","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"0","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"0","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"0","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"0","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"1","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"1","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"1","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"1","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"1","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"1","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"2","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"2","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"2","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"2","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"2","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":"2","utilization":"High","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":">=3","utilization":"Low","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":">=3","utilization":"Low","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":">=3","utilization":"Medium","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":">=3","utilization":"Medium","hardInquiries":">=3","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":">=3","utilization":"High","hardInquiries":"1","expected":"No"},{"creditScore":"Poor","creditAge":">=1","remarks":">=3","utilization":"High","hardInquiries":">=3","expected":"No"}];

        this.tests.forEach((test) => {
            test.actual = this.id3.predict([this.tree], test);
            test.accurate = test.expected === test.actual;
        });
        
        this.accuracyPct =  (filter(this.tests, { accurate: true }).length/ this.tests.length)*100;
    }

}
